<?php

/*
 * FORMA - The E-Learning Suite
 *
 * Copyright (c) 2013-2023 (Forma)
 * https://www.formalms.org
 * License https://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
 *
 * from docebo 4.0.5 CE 2008-2012 (c) docebo
 * License https://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
 */

define('_INSTALLER_TITLE', 'forma.lms - Installation');
define('_NEXT', 'N&auml;chster Schritt');
define('_BACK', 'Zur&uuml;ck');
define('_LOADING', 'Lade');
define('_TRY_AGAIN', 'Erneut versuchen');
//--------------------------------------
define('_TITLE_STEP1', 'Schritt 1: Sprache w&auml;hlen');
define('_LANGUAGE', 'Sprache');
define('_INSTALLER_INTRO_TEXT', 'formalms.org ist eine Firma, die ihre eigene open-source e-learning Umgebung namens forma.lms f&uuml;r komplexe Organisationen, den Wirtschaftssektor, staatliche Unternehmen und den Gesundheitssektor entwickelt hat.
	<p><b>Schl&uuml;sselfunktionen</b></p>
	<ul>
		<li>Scorm 1.2 und 2004 Unterst&uuml;tzung</li>
		<li>F&uuml;r verschiedene Trainingsmodelle konfigurierbar (Selbst-studium, gemischtes Lernen, gemeinschaftliches und soziales Lernen)</li>
		<li>Autorenwerkzeug, dass es erlaubt, Tests, Dateidownloads jeden Formats, Webseiten, FAQs, Glossare und Linksammlungen zu verwalten</li>
		<li>Funktionen zur Zusammenarbeit wie <b>Forum</b>, <b>Wiki</b>, <b>Chat</b>, <b>Projektverwaltung</b> und <b>Ablage</b></li>
		<li>Talent- und Kompetenzverwaltung, L&uuml;ckenanalyse und pers&ouml;nlichen Entwicklungsplan</li>
		<li>Erstellung und Ausdruck von PDF Zertifikaten</li>
		<li>Unterst&uuml;tzung der Schnittstellen Dritter f&uuml;r Personalverwaltungsanwendungen (<b>SAP</b>, <b>Cezanne</b>, <b>Lotus Notes</b>, ...) und andere Firmendienste (<b>LDAP</b>, <b>Active Directory</b>, <b>CRM</b>, <b>Erp</b> und andere individuelle L&ouml;sungen)</li>
		<li>Unterst&ouml;tzung f&uuml;r soziale Anwendungen wie <b>Google Apps</b>, <b>Facebook</b>, <b>Twitter</b> und <b>Linkedin</b></li>
		<li>Komplett konfigurierbares Benachrichtigungssystem und Firmen-Nachrichtendienst</li>
		<li>Spezielle Sub-Administratoren Funktionen, Bereiche und L&auml;nderverwaltungsfunktionen</li>
		<li>Unterst&uuml;tzung f&uuml;r mehrere Sprachen und LTR(links-nach-rechts) bzw. RTL (rechts-nach-links) Schriften. 25 Sprachen werden unterst&uuml;tzt.</li>
		<li>Unterst&uuml;tzung f&uuml;r Mobilger&auml;te</li>
	</ul>');
// ---------------------------------------
define('_TITLE_STEP2', 'Schritt 2: Informationen');
define('_SERVERINFO', 'Serverinformationen');
define('_SERVER_SOFTWARE', 'Server Software : ');
define('_PHPVERSION', 'PHP Version : ');
define('_MYSQLCLIENT_VERSION', 'MySQL/MariaDB Client Version : ');
define('_MYSQLSERVER_VERSION', 'MySQL/MariaDB Server Version : ');
define('_LDAP', 'LDAP : ');
define('_ONLY_IF_YU_WANT_TO_USE_IT', 'Beachten Sie diese Warnung nur, wenn Sie LDAP benutzen ');
define('_OPENSSL', 'Openssl : ');
define('_WARINNG_SOCIAL', 'Consider this warning only if you use social login');

define('_PHPINFO', 'PHP Informationen : ');
define('_MAGIC_QUOTES_GPC', 'magic_quotes_gpc : ');
define('_SAFEMODE', 'Safe mode : ');
define('_REGISTER_GLOBALS', 'register_global : ');
define('_UPLOAD_MAX_FILESIZE', 'upload_max_filsize : ');
define('_POST_MAX_SIZE', 'post_max_size : ');
define('_MAX_EXECUTION_TIME', 'max_execution_time : ');
define('_ALLOW_URL_FOPEN', 'allow_url_fopen : ');
define('_ALLOW_URL_INCLUDE', 'allow_url_include : ');
define('_ON', 'AN ');
define('_OFF', 'AUS ');
// -----------------------------------------
define('_TITLE_STEP3', 'Schritt 3: Lizenz');
define('_AGREE_LICENSE', 'Ich stimme der folgenden Lizenzvereinbarung zu');
// -----------------------------------------
define('_TITLE_STEP4', 'Schritt 4: Konfiguration');
define('_SITE_BASE_URL', 'Basis-URL der Webseite');
define('_DATABASE_INFO', 'Datenbank Informationen');
define('_DB_HOST', 'Adresse');
define('_DB_NAME', 'Datenbank Name');
define('_DB_USERNAME', 'Datenbank Benutzer');
define('_DB_PASS', 'Passwort');
define('_UPLOAD_METHOD', 'Dateiupload Methode (FTP wird empfohlen; benutzen Sie HTTP, wenn Sie zuhause sind und Windows benutzen');
define('_HTTP_UPLOAD', 'Klassische Methode (HTTP)');
define('_FTP_UPLOAD', 'Dateiupload per FTP');
define('_FTP_INFO', 'FTP Zugangsdaten');
define('_IF_FTP_SELECTED', '(Wenn Sie FTP als Methode gew&auml;hlt haben)');
define('_FTP_HOST', 'Serveradresse');
define('_FTP_PORT', 'Portnummer (Vorgabe ist meistens korrekt)');
define('_FTP_USERNAME', 'Benutzername');
define('_FTP_PASS', 'Passwort');
define('_FTP_CONFPASS', 'Password best&auml;tigen');
define('_FTP_PATH', 'FTP Pfad (Verzeichnis, wo Dateien gespeichert werden, z.B. /htdocs/ /mainfile_html/');
define('_CANT_CONNECT_WITH_DB', 'Kann nicht zur Datenbank verbinden, bitte Eingabe &uuml;berpr&uuml;fen');
define('_CANT_SELECT_DB', 'Kann Datenbank nicht ausw&auml;hlen, bitte Eingabe &uuml;berpr&uuml;fen');
define('_CANT_CONNECT_WITH_FTP', 'Kann nicht zum gew&auml;hlten FTP Server verbinden, bitte eingegebene Parameter &uuml;berpr&uuml;fen');
// -----------------------------------------
define('_TITLE_STEP5', 'Schritt 5: Konfiguration');
define('_ADMIN_USER_INFO', 'Informationen bez&uuml;glich des Administratorbenutzers');
define('_ADMIN_USERNAME', 'Benutzername');
define('_ADMIN_FIRSTNAME', 'Vorname');
define('_ADMIN_LASTNAME', 'Nachname');
define('_ADMIN_PASS', 'Passwort');
define('_ADMIN_CONFPASS', 'Passwort best&auml;tigen');
define('_ADMIN_EMAIL', 'e-Mail');
define('_LANG_TO_INSTALL', 'Zu installierende Sprachen');
// -----------------------------------------
define('_TITLE_STEP6', 'Sschritt 6: Datenbank-Daten Konfiguration');
define('_DATABASE', 'Datenbank');
define('_DB_IMPORTING', 'Datenbank importieren');
define('_LANGUAGES', 'Sprachen');
// -----------------------------------------
define('_TITLE_STEP7', 'Step 7: Configurazione SMTP');
define('_SMTP_INFO', "Sarà possibile impostare la configurazione dell'SMTP da backoffice o da config.");
define('_USE_SMTP_DATABASE', 'Impostazioni SMTP su Database');
define('_USE_SMTP', 'Usa SMTP');
define('_SMTP_HOST', 'Host SMTP');
define('_SMTP_PORT', 'Porta SMTP');
define('_SMTP_SECURE', 'Tipo di sicurezza');
define('_SMTP_AUTO_TLS', 'Impostazione Auto TLS SMTP');
define('_SMTP_USER', 'User SMTP');
define('_SMTP_PWD', 'Password SMTP');
define('_SMTP_DEBUG', 'Debug SMTP');
define('_CANT_CONNECT_SMTP', 'impossibile connettersi al server SMTP selezionato');
// -----------------------------------------
define('_TITLE_STEP8', 'Schritt 8: Installation abgeschlossen');
define('_INSTALLATION_COMPLETED', 'Die Installation wurde abgeschlossen');
define('_INSTALLATION_DETAILS', 'Details');
define('_SITE_HOMEPAGE', 'Startseite');
define('_REVEAL_PASSWORD', 'Passwort zeigen');
define('_COMMUNITY', 'Community');
define('_COMMERCIAL_SERVICES', 'Kommerzielle Dienstleistungen');
define('_CONFIG_FILE_NOT_SAVED', 'Der Installationsassistent konnte die config.php Datei nicht speichern, bitte laden Sie sie herunter und speichern Sie diese manuell.');
define('_DOWNLOAD_CONFIG', 'Konfiguration herunterladen');
define('_CHECKED_DIRECTORIES', 'Einige Verzeichnisse, in denen Dateien gespeichert werden sollen, existieren nicht, oder haben falsche Berechtigungen');
define('_CHECKED_FILES', 'Einige Dateien haben keine angemessenen Berechtigungen');
// -----------------------------------------
define('_UPGRADER_TITLE', 'forma.lms - Aktualisierung');
define('_UPGRADE_CONFIG', 'Aktualisiere config.php Datei');
define('_UPG_CONFIG_OK', 'Config.php erfolgreich aktualisiert');
define('_UPG_CONFIG_NOT_CHANGED', 'Config.php already updated');
define('_UPG_CONFIG_NOT_SAVED', 'Die Aktualisierung der config.php Datei ist fehlgeschlagen.');
define('_UPGRADING', 'Aktualisierung l&auml;uft');
define('_UPGRADING_LANGUAGES', 'Aktualisiere Sprachen');
define('_UPGRADE_COMPLETE', 'Aktualisierung abgeschlossen');
